import java.awt.Graphics;


public class AuxClass
{
  protected static int dim;
  protected static Position vectorTable[];
  protected static final double xScale=90.0;
  protected static final double yScale=60.0;
  protected static Graphics gr;

/*  
  public AuxClass(int parDim,Graphics g)
  {
    dim=parDim;
    gr=g;
  } // AuxClass()
*/

  public static void buildVectorTable()
  {
    vectorTable=new Position[dim];
    
    switch (dim)
    {
      case 1:
        vectorTable[0]=new Position(0.0,1.0); // 90
        break;
        
      case 2:
        vectorTable[0]=makeUnitVectorForAngle(135.0);
        vectorTable[1]=makeUnitVectorForAngle( 45.0);
        break;
        
      case 3:
        vectorTable[0]=makeUnitVectorForAngle(135.0);
        vectorTable[1]=new Position(0.0,1.0); // 90
        vectorTable[2]=makeUnitVectorForAngle( 45.0);
        break;
        
      default:
        vectorTable[0]=makeUnitVectorForAngle(150.0);
        vectorTable[dim-1]=makeUnitVectorForAngle(30.0);
        double step=120.0/(double)(dim-1);
        double curr=150.0;
          
        if (dim%2==1) // odd: 5,7,9,...
        {
          int middleIndex=(dim-1)/2;
          vectorTable[middleIndex]=new Position(0.0,1.0); // = 90
          
          for (int i=1; i<(dim-1); i++)
          {
            curr-=step;
            if (i!=middleIndex) vectorTable[i]=makeUnitVectorForAngle(curr);
          }
        }
        else // even: 4,6,8,...
        {
          for (int i=1; i<(dim-1); i++)
          {
            curr-=step;
            vectorTable[i]=makeUnitVectorForAngle(curr);
          }
        } // else
        break;
    } // switch
  } // buildVectorTable()


  protected static Position makeUnitVectorForAngle(double angleDeg)
  {
    double rad=Math.toRadians(angleDeg);
    return new Position(Math.cos(rad),Math.sin(rad));
  } // makeUnitVectorForAngle()


  public static Position getVector(int parIndex)
  {
    //System.out.println("AuxClass.getVector(): parIndex="+parIndex);
    //System.out.print("AuxClass.getVector(): vec=");
    //if (p==null) System.out.println("null!");
    //else System.out.println(p.toString());
    return vectorTable[parIndex];
  } // getVector()


  public static Position buildCoord(Position vec,Position pos)
  {
    //return new Position(vec.getX()*xScale+pos.getX(),vec.getY()*yScale+pos.getY());
    return new Position(vec.getX()*xScale+pos.getX(),pos.getY()-vec.getY()*yScale);
  } // buildCoord()


  public static void drawLine(Position p1,Position p2)
  {
    gr.drawLine((int)p1.getX(),(int)p1.getY(),(int)p2.getX(),(int)p2.getY());
  } // drawLine()
  
} // class AuxClass