import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;


public class CubeCanvas extends Canvas
{
  private int width=0;
  private int height=0;
  private int dim=0;
   /** The buffered image, which stores all graphics components of this PlayerCanvas. */
  private BufferedImage bimg = null;

  public CubeCanvas(int parDim)
  {
    dim=parDim;
  }
   
  public void setSize(Dimension d)
  {
    super.setSize(d);
    height=getHeight();
    width=getWidth();
  }
  
  public void paint(Graphics g)
  {
    if (bimg==null) createBufImage();
    g.drawImage(bimg, 0, 0, this);
  } // paint()
  
  private void createBufImage()
  {
    if (bimg == null || bimg.getWidth() != width || bimg.getHeight() != height)
      bimg = (BufferedImage)createImage(width, height);
   	Graphics2D g2 = bimg.createGraphics();
    g2.setBackground(Color.black);
    g2.clearRect(0, 0, width, height);
    //g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON); //antialiasing
    g2.setPaint(Color.white);
    drawCubeOnGraphics(g2);
  } // createBufImage()
  
  private void drawCubeOnGraphics(Graphics2D g2)
  {
    //AuxClass aux=new AuxClass(dim,g2);
    AuxClass.dim=this.dim;
    AuxClass.gr=g2;
    AuxClass.buildVectorTable();
    
    boolean rootDigits[]=new boolean[dim];
    for (int i=0; i<dim; i++) rootDigits[i]=false;
    
    //Node root=new Node(aux,dim,rootDigits);
    Main.root=new Node(rootDigits);
    Main.root.setPosition(new Position(280,450));
    //aux.setRoot(root);
    
    Main.root.makeChildren();
  } // drawCubeOnGraphics()

} // class CubeCanvas