import java.awt.*;
import java.awt.event.*;


public class Main extends Frame
{
  public static int dim;
  public static Node root=null;
  CubeCanvas myCanvas = null;
  Panel workPanel = new Panel();
  Button exitButton = new Button("Exit");
  
  public Main()
  {
    setBackground(new Color(170,170,170));
    setResizable(false);
    try {initComponents();} catch (Exception e) {}
    setLocation(100,100);
    setVisible(true);
  } // Main()
  
  public void initComponents() throws Exception
  {
    myCanvas=new CubeCanvas(dim);
    myCanvas.setSize(new Dimension(512, 512));
    myCanvas.setLocation(new Point(10, 25));
    myCanvas.setVisible(true);
    
    workPanel.setSize(new Dimension(120, 512));
    workPanel.setLocation (new Point(530, 25));
    workPanel.setBackground(Color.lightGray);
    workPanel.setVisible(true);

    exitButton.setSize(new Dimension(80, 20));
    exitButton.setVisible(true);
    exitButton.setLocation(new Point(550, 80));

    setSize(new Dimension(661, 550));
    setLayout(null);
    setTitle("Cube");
    setLocation(new Point(0, 0));

    add(myCanvas);
    add(exitButton);
    add(workPanel);
    
    exitButton.addActionListener(new ActionListener()
    { public void actionPerformed(ActionEvent e) { exitButtonActionPerformed(e); } });

    addWindowListener(new WindowAdapter()
    { public void windowClosing(WindowEvent e) {thisWindowClosing(e);} });
  } // initComponents()


  protected void thisWindowClosing(WindowEvent e)
  {
    setVisible(false);
    dispose();
    System.exit(0);
  } // thisWindowClosing()
  

  public void exitButtonActionPerformed(ActionEvent e)
  {
    setVisible(false);
    dispose();
    System.exit(0);
  }

  
  public static void usage()
  {
    System.out.println("Usage: java Main dimension");
    System.exit(1);
  } // usage()
  
  
  public static void main(String[] args)
  {
    if (args.length!=1) usage();
    
    int ldim=0;
    
    try
    {
      ldim=Integer.parseInt(args[0]);
    }
    catch (NumberFormatException nfe)
    {
      usage();
    }
    
    if (ldim<1 || ldim>10)
    {
      System.out.println("Allowed range of dimension: 1..10");
      System.exit(2);
    }
    
    Main.dim=ldim;
    new Main();
  } // main()
} // class Main
